/***********************************************************************

                                       CSA Library, Release 1.5.b 

       Defining the PANEL class.

                                          Copyright(c) 1994 
                                          Combis 
                                          The Netherlands   
***********************************************************************/

#ifndef __CSPANEL_H
#define __CSPANEL_H


#ifndef __CSWINDOW_H
  #include "cswindow.h"
#endif
#ifndef __CSFIELD_H
  #include "csfield.h"
#endif

#define MAX_FIELDS  35
#define mod_field  field()


class PANEL: public WINDOW
{
private:

   int num_field;
   int exitkey;
   int use_exit_f;
   int esc_allow;
   int fieldcolor;
   int is_changed;

   FIELD *fields[MAX_FIELDS+1];   // pointers to the fields

protected:
   int calc_changed(void);
   int add_field(int r,int k,int le,FIELD *fpp);



public:
   int add_field(int r,int k,char *s) { return add_field(r,k,strlen(s),s); }
   int add_field(int r,int k,int le,char *s) ;
   int add_field(int r,int k,int dl,int ml, char *s) ;
   int add_field(int r,int k,int le,char &ch) ;
   int add_field(int r,int k,int le,int &i) ;
   int add_field(int r,int k,int le,long &l) ;
   int add_field(int r,int k,int le,float &t) ;
   int add_field(int r,int k,int le,double &d) ;
   int add_field(int r,int k,int le,DATE &d) ;
   int add_field(int r,int k,DATE &d) { return add_field(r,k,d.long_year()*2+8,d); }

   int read(void);
   void display(void);
   void recreate(void);

   int changed(void)		      { return is_changed; }
   FIELD& field(void)		      { return field(num_field-1); }
   FIELD& field(int num)	      { return *fields[num]; }
   void protect(int ebd);
   void protect(int field,int ebd);
   void exit_key(int tf)	      { exitkey=tf; }
   void exit_field(int num,int tf);
   void exit_field(int tf)	      { exit_field(num_field-1,tf); }
   void escape_off(void)	      { escape(FALSE); }
   void escape_on(void) 	      { escape(TRUE); }
   void escape(int tf)		      { esc_allow=tf; }
   void remove(void);
   void field_color(int c)	      { fieldcolor=c; }
   int	field_color(void)	      { return fieldcolor; }
   void color(int borc,int scrc,int fiec)
				      { border_color(borc);
					screen_color(scrc);
					field_color(fiec);
				      }
   PANEL(void);
   ~PANEL(void);

};



#endif
